AWSTemplateFormatVersion: "2010-09-09"

Description: ST-DW-DB Layer
# Stack name - ST-DW-DB
Parameters:
  AMIImage:
    Type: String
    Default: ami-d169d7b1
  AdminPassword:
    Type: String
    Default: Qazx123!#
  ServerName:
    Type: String
    Default: st-dw-db-1a
  ServerIpAddress:
    Type: String
    Default: 10.1.73.11
  DNSServer:
    Type: String
    Default: 10.1.74.11
  NetAdapterName:
    Type: String
    Default: Subnet 73

Resources:
  # 1 - Create AWS identity and IAM instance profile
  InstanceProfile:
    Type: AWS::IAM::InstanceProfile
    Properties:
      Path: /
      Roles:
        - STServersRole

  # 1 - Create ST-DW-DB-1A
  STDWDB1a:
    Type: AWS::EC2::Instance
    Properties:
      ImageId:
        Ref: AMIImage
      Tags:
        - Key: Name
          Value:
            Ref: ServerName
      InstanceType: t2.medium
      DisableApiTermination: False
      InstanceInitiatedShutdownBehavior: stop
      Monitoring: False
      KeyName: "ST-Sviridov-OR"
      IamInstanceProfile:
        Ref: InstanceProfile
      BlockDeviceMappings:
        - DeviceName: "/dev/sda1"
          Ebs:
            VolumeType: "standard"
            VolumeSize: "100"
        - DeviceName: "/dev/xvdf"
          Ebs:
            VolumeType: "standard"
            VolumeSize: "40"
        - DeviceName: "/dev/xvdg"
          Ebs:
            VolumeType: "standard"
            VolumeSize: "40"
      NetworkInterfaces:
        - AssociatePublicIpAddress: "false"
          DeviceIndex: "0"
          GroupSet:
            - !ImportValue STDWDBSecGP
          PrivateIpAddress:
            Ref: ServerIpAddress
          SubnetId: !ImportValue STDWDbSubnetA
      UserData:
        Fn::Base64:
          Fn::Join:
            - ''
            - - "<powershell>\n"
              - "([ADSI]'WinNT://./Administrator,user').SetPassword('"          #Set ADMIN password
              - Ref: AdminPassword
              - "')\n"
              - "Get-NetAdapter | Rename-NetAdapter -NewName '"                 #Set NetAdapter name
              - Ref: NetAdapterName
              - "'\n"
              - "Set-DnsClientServerAddress -InterfaceAlias '"                  #Set DNS clients
              - Ref: NetAdapterName
              - "' -ServerAddresses ('"
              - Ref: DNSServer
              - "')\n"
              - "Rename-Computer ('"                                            #Rename Computer
              - Ref: ServerName
              - "').ToUpper() -Force -Restart\n"
              - "</powershell>"

Outputs:
  STDWDB1a:
    Value:
      Ref: STDWDB1a
    Export:
      Name: STDWDB1a
